import org.apache.commons.lang.StringEscapeUtils;

if (renderContext.getRequest().getParameterMap().containsKey("skipWem")) {
    return;
}

htmlHeadContent.append("<jahia:resource type=\"javascript\" key=\"\" path=\"" + renderContext.getRequest().getContextPath() + "/modules/marketing-factory-core/javascript/marketing-factory/live-mode/wem.js\" />\n");
interests = ""
if (resource.node.properties['wem:interests']) {
    values = resource.node.properties['wem:interests'];
    interests = ",\n            \"interests\":{\n                "
    interests += (values.collect() { it.string.contains(':') ? it.string.split(":") : [it.string, 1] }
            .collect() { "\"" + it[0].toLowerCase() + "\":" + it[1] }
            .join(','))
    interests += "\n            }"
}

contextServerUrl = renderContext.getRequest().isSecure()?contextServerSecureUrl:contextServerPublicUrl;
pageName = StringEscapeUtils.escapeJavaScript(resource.node.displayableName);

userName = null;
if (renderContext.getUser() != null && renderContext.getUser().getUsername() != null) {
    userName = renderContext.getUser().getUsername();
}

p = """\
<script type="text/javascript">
    window.digitalData = {
        "scope": "${scope}",
        "site": {
            "siteInfo": {
                "siteID": "${resource.node.resolveSite.identifier}"
            }
        },
        "page": {
            "pageInfo": {
                "pageID": "${resource.node.identifier}",
                "pageName": "${pageName}",
                "pagePath": "${resource.node.path}",
                "destinationURL": document.location.href,
                "referringURL": "${renderContext.request.getHeader('referer')}",
                "language": "${resource.locale}"
            },
            "category": {},
            "attributes": {
            }${interests}
        },
        "contextServerPublicUrl": "${contextServerUrl}"
    };
    if (${resource.node.isNodeType('jnt:page')}) {
        if (${resource.node.isNodeType('wemmix:personalizedPage')}) {
            window.digitalData.page.pageInfo.isPersonalized = true;
            window.digitalData.page.pageInfo.wemType = 'page_personalization';
            var displayWemVariantEvent = document.createEvent('CustomEvent');
            displayWemVariantEvent.initCustomEvent('displayWemVariant', false, false, {
                "type": "page_personalization",
                "variantWrapperPath": "${resource.node.path}",
                "variantPath": "${resource.node.path}",
                "pagePath": "${resource.node.path}",
                "variantWrapper": "${resource.node.identifier}",
                "variant": "${resource.node.identifier}"
            });
            document.dispatchEvent(displayWemVariantEvent);
        }
        if (${resource.node.isNodeType('wemmix:optimizationTestPage')}) {
            window.digitalData.page.pageInfo.isPersonalized = true;
            window.digitalData.page.pageInfo.wemType = 'page_optimization';
            var displayWemVariantEvent = document.createEvent('CustomEvent');
            displayWemVariantEvent.initCustomEvent('displayWemVariant', false, false, {
                "type": "page_optimization",
                "variantWrapperPath": "${resource.node.path}",
                "variantPath": "${resource.node.path}",
                "pagePath": "${resource.node.path}",
                "variantWrapper": "${resource.node.identifier}",
                "variant": "${resource.node.identifier}"
            });
            document.dispatchEvent(displayWemVariantEvent);
        }
    } else {
        window.digitalData.page.pageInfo.isPersonalized = true;
        if (${resource.node.isNodeType('wemnt:pageVariant')}) {
            if (${resource.node.getParent().isNodeType('wemmix:optimizationTestPage')}) {
                window.digitalData.page.pageInfo.isPersonalized = true;
                window.digitalData.page.pageInfo.wemType = 'page_optimization';
                var displayWemVariantEvent = document.createEvent('CustomEvent');
                displayWemVariantEvent.initCustomEvent('displayWemVariant', false, false, {
                    "type": "page_optimization",
                    "variantWrapperPath": "${resource.node.getParent().path}",
                    "variantPath": "${resource.node.path}",
                    "pagePath": "${resource.node.path}",
                    "variantWrapper": "${resource.node.getParent().identifier}",
                    "variant": "${resource.node.identifier}"
                });
                document.dispatchEvent(displayWemVariantEvent);
            }
            if (${resource.node.getParent().isNodeType('wemmix:personalizedPage')}) {
                window.digitalData.page.pageInfo.isPersonalized = true;
                window.digitalData.page.pageInfo.wemType = 'page_personalization';
                var displayWemVariantEvent = document.createEvent('CustomEvent');
                displayWemVariantEvent.initCustomEvent('displayWemVariant', false, false, {
                    "type": "page_personalization",
                    "variantWrapperPath": "${resource.node.getParent().path}",
                    "variantPath": "${resource.node.path}",
                    "pagePath": "${resource.node.path}",
                    "variantWrapper": "${resource.node.getParent().identifier}",
                    "variant": "${resource.node.identifier}"
                 });
                 document.dispatchEvent(displayWemVariantEvent);
            }
        }
    }
    wem.init('${contextServerUrl}', '${proxyServletUrl}', ${renderContext.isPreviewMode()}, ${timeoutInMilliseconds}, '${userName}');
  </script>
"""

htmlHeadContent.append("<jahia:resource type=\"inlinejavascript\" key=\"cxsLoadEvent\" path=\"" + URLEncoder.encode(p, "UTF-8") + "\" />");

