(function() {
    'use strict';

    angular.module('wemApp.components').controller('AddToListsActionController', AddToListsActionController);

    AddToListsActionController.$inject = ['i18nService', 'unomiListService'];

    function AddToListsActionController(i18nService, unomiListService) {

        var vm = this;

        vm.setParentRef = setParentRef;
        vm.selectLists = selectLists;

        // public functions

        function setParentRef(parentRef) {
            vm.parentRef = parentRef;
            _init();
        }

        function selectLists() {
            vm.parentRef.parameterValues.listIdentifiers = vm.addToListsAction.selectedLists;
        }

        // private functions

        function _init() {

            vm.addToListsAction = {};

            unomiListService.getAll().then(function (response) {
                vm.lists = response.data.list;
                vm.addToListsAction.selectedLists = (vm.parentRef.parameterValues.listIdentifiers != null && vm.parentRef.parameterValues.listIdentifiers);
            });

        }

    }
})();