(function() {
    'use strict';

    angular.module('wemApp').run(wemAppRun);

    wemAppRun.$inject = ['$rootScope', '$window', '$location', 'notificationService', 'i18nService', 'amMoment'];

    function wemAppRun($rootScope, $window, $location, notificationService, i18nService, amMoment) {
        i18nService.initMap(wemi18n);

        amMoment.changeLocale(ManagersContext.jahiaUILocale);

        if (!wemAppIsNewUI) {
            ManagersUtils.notificationService = notificationService;
        }

        // To manage context server issue and display a page
        $rootScope.$on('$locationChangeStart', function (event, nextUrl, currentUrl) {
            if (!ManagersContext.isAllowedByLicense) {
                _redirectHandler(event, nextUrl, currentUrl);
            } else if ((!ManagersContext.contextServerSetup && $window.location.pathname.indexOf('.marketing-90-settings.html') == -1)
                || (!ManagersContext.contextServerOnline && $window.location.pathname.indexOf('.marketing-90-settings.html') == -1)) {
                _redirectHandler(event, nextUrl, currentUrl);
            }
        });

        $rootScope.$on('$locationChangeSuccess', function (event, newUrl) {
            // only executed if not in edit frame
            if ($window.parent.location.pathname.indexOf('/editframe/') == -1) {
                $window.parent.location.hash = "#" + $location.path();
            }
        });

        // Private functions under this line
        function _redirectHandler(event, nextUrl, currentUrl) {
            if (nextUrl.indexOf('#!/context-server-issue') == -1
                && currentUrl.indexOf('#!/context-server-issue') == -1) {
                // Context server is not setup and nextUrl and current URL are not going to right view
                $location.path('/context-server-issue');
                event.preventDefault();
            }

            if (nextUrl.indexOf('#!/context-server-issue') == -1
                && currentUrl.indexOf('#!/context-server-issue') != -1) {
                // context server is not setup and current URL is going to the right view
                event.preventDefault();
            }
        }
    }
})();