(function() {
    'use strict';

    angular.module('wemApp.components').directive('wemEditframeMenu', wemEditframeMenu);

    wemEditframeMenu.$inject = ['$window'];

    function wemEditframeMenu($window) {
        return {
            restrict: 'A',
            templateUrl: ManagersContext.wemAppPath + '/components/wem-editframe-menu.directive.html',
            controller: WemEditframeMenuController,
            controllerAs: 'wemEditframeMenuCtrl',
            link: linkFunc
        };

        function linkFunc(scope, el) {
            scope.displayMenu = false;
            if ($window.parent.location.pathname.indexOf('/editframe/') != -1) {
                el.addClass('wem-editframe-menu');
                scope.displayMenu = true;
            }
        }
    }

    WemEditframeMenuController.$inject = ['$window', '$filter'];

    function WemEditframeMenuController($window, $filter) {
        var wemEditframeMenuCtrl = this;
        wemEditframeMenuCtrl.getLink = getLink;
        wemEditframeMenuCtrl.goTo = goTo;
        wemEditframeMenuCtrl.toggleMenu = toggleMenu;
        wemEditframeMenuCtrl.getMenuEntryClass = getMenuEntryClass;
        wemEditframeMenuCtrl.menuEntries = $filter('orderBy')(ManagersContext.editframeMenu, 'name');

        function getLink(entryName) {
            return ManagersContext.baseEdit.replace('/edit/', '/editframe/') + ManagersContext.currentSitePath + '.' + entryName + '.html';
        }

        function goTo(entryName) {
            $window.parent.location = ManagersContext.baseEdit.replace('/edit/', '/editframe/') + ManagersContext.currentSitePath + '.' + entryName + '.html';
        }

        function toggleMenu(index) {
            wemEditframeMenuCtrl.menuEntries[index].toggle = !wemEditframeMenuCtrl.menuEntries[index].toggle;
        }

        function getMenuEntryClass(entryPathKey, parent) {
            var isOpen = ($window.parent.location.pathname.indexOf(entryPathKey) != -1);
            if (parent && isOpen) {
                parent.toggle = true;
            }
            return isOpen ? 'active' : '';
        }
    }
})();