(function() {
    'use strict';
    // Todo: replace by angular material messages
    angular.module('wemApp.components').directive('wemLowerThanNumber', wemLowerThanNumber);

    function wemLowerThanNumber() {
        return {
            require: 'ngModel',
            link: linkFunc
        };

        function linkFunc(scope, element, attrs, ctrl) {
            var validate = function (viewValue) {
                var comparisonModel = attrs.lowerThanNumber;
                var view = parseInt(viewValue, 10);
                var comparison = parseInt(comparisonModel, 10);

                if (view && comparison) {
                    // It's valid because we have nothing to compare against
                    ctrl.$setValidity('lowerThan', view < comparison);
                } else {
                    ctrl.$setValidity('lowerThan', true);
                }

                return viewValue;
            };

            ctrl.$parsers.unshift(validate);
            ctrl.$formatters.push(validate);

            attrs.$observe('lowerThanNumber', function (comparisonModel) {
                // Whenever the comparison model changes we'll re-validate
                return validate(ctrl.$viewValue);
            });
        }
    }
})();