(function() {
    'use strict';

    angular.module('wemApp.components').directive('wemPrefixModelByProperties', wemPrefixModelByProperties);

    function wemPrefixModelByProperties() {
        return {
            require: 'ngModel',
            restrict: 'A',
            scope: {ngModel: '='},
            link: linkFunc
        };

        function linkFunc(scope, element, attr, controller) {
            controller.$formatters.unshift(function (valueFromModel) {
                // what you return here will be passed to the text field
                if(valueFromModel && valueFromModel.lastIndexOf("properties.", 0) === 0) {
                    return valueFromModel.substr("properties.".length);
                }
                return valueFromModel;
            });

            controller.$parsers.push(function (valueFromInput) {
                // put the inverse logic, to transform formatted data into model data
                // what you return here, will be stored in the $scope
                return "properties." + valueFromInput;
            });
        }
    }
})();