(function() {
    'use strict';

    angular.module('wemApp.components').controller("GoalConditionController", GoalConditionController);

    GoalConditionController.$inject = ['$scope', 'unomiGoalService'];

    function GoalConditionController($scope, unomiGoalService) {
        $scope.operators = [
            {
                "id": "exists",
                "name": "comparisonOperator.exists"
            }, {
                "id": "missing",
                "name": "comparisonOperator.missing"
            }
        ];

        unomiGoalService.getAll().then(function (response) {
            $scope.goalsChoiceListValues = response.data;
            if(!$scope.ref.parameterValues.comparisonOperator){
                $scope.ref.parameterValues.comparisonOperator = "exists";
            }
        });

    }

    angular.module('wemApp.components').filter('isNotAnOptimizationGoal', isNotAnOptimizationGoalFilter);

    function isNotAnOptimizationGoalFilter() {
        return function (goalList) {
            var newGoalList = [];
            angular.forEach(goalList, function(goal) {
                if (goal.id.indexOf('optimizationTestGoal_') == -1) {
                    newGoalList.push(goal);
                }
            });
            return newGoalList;
        }
    }
})();
