(function() {
    'use strict';

    angular.module('wemApp.components').controller("ScoringConditionController", ScoringConditionController);

    ScoringConditionController.$inject = ['$scope', 'unomiScoringService'];

    function ScoringConditionController($scope, unomiScoringService) {
        $scope.operators = [
            {
                "id": "equals",
                "name": "comparisonOperator.equals",
                "appliesTo": ["email", "string", "integer"]
            }, {
                "id": "notEquals",
                "name": "comparisonOperator.notEquals",
                "appliesTo": ["integer"]
            }, {
                "id": "lessThan",
                "name": "comparisonOperator.lessThan",
                "appliesTo": ["integer"]
            }, {
                "id": "greaterThan",
                "name": "comparisonOperator.greaterThan",
                "appliesTo": ["integer"]
            }, {
                "id": "lessThanOrEqualTo",
                "name": "comparisonOperator.lessThanOrEqualTo",
                "appliesTo": ["integer"]
            }, {
                "id": "greaterThanOrEqualTo",
                "name": "comparisonOperator.greaterThanOrEqualTo",
                "appliesTo": ["integer"]
            }
        ];
        unomiScoringService.getAll().then(function (response) {
            var data = response.data;
            $scope.scoringChoiceListValues = {};
            console.log($scope.scoringChoiceListValues);
            $scope.scoringChoiceListValues = _.reject(data, function (scoring) {
                                                    return (scoring.id === $scope.$parent.$parent.scoringId) ||
                                                        (scoring.scope != 'systemscope' &&
                                                    scoring.scope != ManagersContext.dmfScope);
                                                });

            console.log($scope.scoringChoiceListValues);
            if (!$scope.ref.parameterValues.scoringPlanId && $scope.scoringChoiceListValues.length > 0) {
                $scope.ref.parameterValues.scoringPlanId =  $scope.scoringChoiceListValues[0].id;
                $scope.ref.parameterValues.scoreValue = 0;
                $scope.ref.parameterValues.comparisonOperator = 'greaterThanOrEqualTo';
            }
        });
    }
})();
