(function() {
    'use strict';

    angular.module('wemApp.services').service('filteringService', filteringService);

    filteringService.$inject = ['_'];

    function filteringService(_) {
        return {
            filterItems: filterItems
        };

        function filterItems(items, service) {
            if (service.deletedItem) {
                items = _.filter(items, function (item) {
                    return item.id != service.deletedItem
                });
            }
            if (service.newItem) {
                var found = false;
                items = _.map(items, function (item) {
                    if (item.id == service.newItem.metadata.id) {
                        found = true;
                        return service.newItem.metadata;
                    } else {
                        return item;
                    }
                });
                if (!found) {
                    items.push(service.newItem.metadata);
                }
            }
            delete service.newItem;
            delete service.deletedItem;

            return items;
        }
    }
})();