(function() {
    'use strict';

    if (wemAppIsNewUI) {
        angular.module('wemApp.services').service('notificationService', notificationNewUiService);

        notificationNewUiService.$inject = ['$mdToast'];
    } else {
        angular.module('wemApp.services').service('notificationService', notificationOldUiService);

        notificationOldUiService.$inject = ['Notification'];
    }

    function notificationOldUiService(Notification) {
        return {
            successToast: successToast,
            errorToast: errorToast
        };

        function successToast(message) {
            Notification.success(message);
        }

        function errorToast(message) {
            Notification.error(message);
        }
    }

    function notificationNewUiService($mdToast) {
        return {
            successToast: successToast,
            errorToast: errorToast
        };

        function successToast(message) {
            $mdToast.show(
                $mdToast.simple()
                    .textContent(message)
                    .position('bottom left')
                    .hideDelay(5000)
                    .parent(angular.element("section[wem-main-section]"))
            );
        }

        function errorToast(message) {
            $mdToast.show(
                $mdToast.simple()
                    .textContent(message)
                    .theme('error-toast')
                    .position('bottom left')
                    .hideDelay(5000)
                    .parent(angular.element("section[wem-main-section]"))
            );
        }
    }
})();