(function() {
    'use strict';

    angular.module('wemApp.services').service('unomiDefinitionService', unomiDefinitionService);

    unomiDefinitionService.$inject = ['$http'];

    function unomiDefinitionService($http) {
        var _definitionsContext = ManagersContext.proxyServletUrl + ManagersUtils.cxsContext + 'definitions/';

        return {
            getTag: getTag,
            getConditionType: getConditionType,
            getConditionTypes: getConditionTypes,
            getConditionTypesByTag: getConditionTypesByTag,
            fillTags: fillTags,
            resolveProfileTags: resolveProfileTags
        };

        function getTag(tag) {
            return $http.get(_definitionsContext + 'tags/' + tag)
        }

        function getConditionType(conditionType) {
            return $http.get(_definitionsContext + 'conditions/' + conditionType)
        }
        
        function getConditionTypes() {
            return $http.get(_definitionsContext + 'conditions')
        }

        function getConditionTypesByTag(tag) {
            return $http.get(_definitionsContext + 'conditions/tags/' + tag)
        }

        function fillTags(arrayName, $scope) {
            $scope.$watch(arrayName + ".length", function (newVal, oldVal, scope) {
                angular.forEach($scope[arrayName], function (item) {
                    if (ManagersContext.conditionsTags && ManagersContext.conditionsTags[item.id]) {
                        item.profileTag = ManagersContext.conditionsTags[item.id];
                    } else {
                        angular.forEach(item.tags, function (tag) {
                            if ($scope.tags[tag]) {
                                item.profileTag = tag;
                            }
                        });
                    }
                });
            });
        }

        function resolveProfileTags(arrayToFill, tags) {
            angular.forEach(arrayToFill, function (item) {
                if (ManagersContext.conditionsTags && ManagersContext.conditionsTags[item.id]) {
                    item.profileTag = ManagersContext.conditionsTags[item.id];
                } else {
                    angular.forEach(item.tags, function (tag) {
                        if (tags[tag]) {
                            item.profileTag = tag;
                        }
                    });
                }
            });
        }
    }
})();