(function() {
    'use strict';

    angular.module('wemApp.services').service('unomiGeonamesService', unomiGeonamesService);

    unomiGeonamesService.$inject = ['$http'];

    function unomiGeonamesService($http) {
        return {
            getEntries: getEntries,
            getHierarchy: getHierarchy,
            getCities: getCities,
            getCapital: getCapital,
            reverseGeoCode: reverseGeoCode
        };

        function getEntries() {
            var url = ManagersContext.proxyServletUrl + ManagersUtils.cxsContext + 'geonames/entries';
            var length = url.length;
            if (arguments.length > 0) {
                for (var i = 0; i < arguments.length; i++) {
                    url = url + ("/" + arguments[i]);
                }
            }
            if (length == url.length) {
                url += "/";
            }

            return $http.get(url);
        }

        function getHierarchy(administrativeSbudivision) {
            return $http.get(ManagersContext.proxyServletUrl + ManagersUtils.cxsContext + 'geonames/hierarchy/' + administrativeSbudivision);
        }

        function getCities() {
            var url = ManagersContext.proxyServletUrl + ManagersUtils.cxsContext + 'geonames/cities';
            var length = url.length;
            if (arguments.length > 0) {
                for (var i = 0; i < arguments.length; i++) {
                    if (arguments[i]) {
                        url = url + ("/" + arguments[i]);
                    }
                }
            }
            if (length == url.length) {
                url += "/";
            }
            return $http.get(url);
        }

        function getCapital(itemId) {
            var url = ManagersContext.proxyServletUrl + ManagersUtils.cxsContext + 'geonames/capitals/' + itemId;
            return $http.get(url);
        }

        function reverseGeoCode(lat, lon) {
            var url = ManagersContext.proxyServletUrl + ManagersUtils.cxsContext + 'geonames/reverseGeoCode/' + lat + ',' + lon;
            return $http.get(url);
        }
    }
})();