(function() {
    'use strict';

    angular.module('wemApp.services').service('unomiImportConfigService', unomiImportConfigService);

    unomiImportConfigService.$inject = ['$http', '$q'];

    function unomiImportConfigService($http, $q) {
        var _importConfigContext = ManagersContext.proxyServletUrl + ManagersUtils.cxsContext + 'importConfiguration/';
        var _importConfigOneshotContext = ManagersContext.proxyServletUrl + ManagersUtils.cxsContext + 'importConfiguration/oneshot/';
        var _selectedTab;

        return {
            getAll: getAll,
            setImportConfig: setImportConfig,
            setOneshotImportConfig: setOneshotImportConfig,
            getImportConfig: getImportConfig,
            deleteImportConfig: deleteImportConfig
        };

        function getAll(limit, offset, sortby) {
            var actualLimit = limit || 100;
            var actualOffset = offset || 0;
            var actualSortBy = sortby || null;
            return $http.get(_importConfigContext);
        }

        function setImportConfig(importConfig) {
            return $http.post(_importConfigContext, importConfig);
        }

        function setOneshotImportConfig(importConfig, files) {
            var deferred = $q.defer();
            setImportConfig(importConfig).then(function(savedImportConfig) {
                var formData = new FormData();
                formData.append('importConfigId', savedImportConfig.data.itemId);
                if(files[0] && !files[0].isRemote){
                    formData.append('file', files[0].lfFile);
                }
                $http.post(_importConfigOneshotContext, formData, {
                    transformRequest: angular.identity,
                    headers: {'Content-Type': undefined}
                }).then(function (response) {
                    deferred.resolve({msg:response});
                });
            });

            return deferred.promise;

        }

        function getImportConfig(id) {
            return $http.get(_importConfigContext + id);
        }

        function deleteImportConfig(id) {
            return $http.delete(_importConfigContext + id);
        }
    }
})();