(function() {
    'use strict';

    angular.module('wemApp.services').service('unomiRulesService', unomiRulesService);

    unomiRulesService.$inject = ['$http'];

    function unomiRulesService($http) {
        var _rulesContext = ManagersContext.proxyServletUrl + ManagersUtils.cxsContext + 'rules/';
        var _rulesStatisticsContext = ManagersContext.proxyServletUrl + ManagersUtils.cxsContext + 'rules/statistics';

        return {
            getAll: getAll,
            setRule: setRule,
            getRule: getRule,
            deleteRule: deleteRule,
            getStatistics : getStatistics
        };

        function getAll(limit, offset, sortby) {
            var actualLimit = limit || 100;
            var actualOffset = offset || 0;
            var actualSortBy = sortby || null;
            return $http.post(_rulesContext + "query", {
                "condition": {
                    "type": "booleanCondition",
                    "parameterValues": {
                        "operator": "or",
                        "subConditions": [
                            {
                                "type": "sessionPropertyCondition",
                                "parameterValues": {
                                    "propertyName": "metadata.scope",
                                    "comparisonOperator": "equals",
                                    "propertyValue": ManagersContext.dmfScope
                                }
                            },
                            {
                                "type": "sessionPropertyCondition",
                                "parameterValues": {
                                    "propertyName": "metadata.scope",
                                    "comparisonOperator": "equals",
                                    "propertyValue": "systemscope"
                                }
                            }
                        ]
                    }
                },
                "limit": actualLimit,
                "offset": actualOffset,
                "sortby": actualSortBy
            });
        }

        function setRule(rule) {
            return $http.post(_rulesContext, rule);
        }

        function getRule(id) {
            return $http.get(_rulesContext + id);
        }

        function deleteRule(id) {
            return $http.delete(_rulesContext + id);
        }

        function getStatistics() {
            return $http.get(_rulesStatisticsContext);
        }
    }
})();