(function() {
    'use strict';

    angular.module('wemCampaignsApp').controller('CampaignCreateEventModalController', CampaignCreateEventModalController);

    CampaignCreateEventModalController.$inject = ['$scope', '$uibModalInstance', 'currentCampaign', 'i18nService'];

    function CampaignCreateEventModalController($scope, $uibModalInstance, currentCampaign, i18nService) {
        //The new campaign
        $scope.currentCampaign = currentCampaign;

        $scope.campaignEvent = {};
        $scope.campaignEvent.eventDate = new Date();
        $scope.currentText = i18nService.message('serverSettings.manageWem.datepicker.today');
        $scope.closeText = i18nService.message('serverSettings.manageWem.datepicker.close');
        $scope.clearText = i18nService.message('wem.label.clear');

        $scope.datePickerOptions = {
            minDate: $scope.currentCampaign.startDate,
            maxDate: $scope.currentCampaign.endDate
        };

        // Calendar functions
        $scope.open = function ($event, selector) {
            $event.preventDefault();
            $event.stopPropagation();
            if (selector == 'start')
                $scope.startopened = true;
            if (selector == 'end')
                $scope.endopened = true;
        };

        $scope.dateOptions = {
            formatYear: 'yyyy',
            startingDay: 1
        };

        $scope.formats = ['dd-MMMM-yyyy', 'yyyy/MM/dd', 'dd.MM.yyyy', 'shortDate'];
        $scope.format = $scope.formats[0];

        //Timepicker functions
        $scope.campaignEvent.startTime = new Date();

        $scope.ok = function () {
            $uibModalInstance.close($scope.campaignEvent);
        };

        $scope.cancel = function () {
            $uibModalInstance.dismiss('cancel');
        };

        $scope.campaignEvent.cost = 0.0;

        $scope.campaignEvent.currency = $scope.currencies[_.findIndex($scope.currencies, {value: currentCampaign.currency})];
        $scope.campaignEvent.timezone = $scope.timezones[_.findIndex($scope.timezones, {label: currentCampaign.timezone})];
    }
})();
