(function() {
    'use strict';

    angular.module('wemExportConfigsApp').config(wemExportConfigsAppConfig);

    wemExportConfigsAppConfig.$inject = ['$routeProvider'];

    function wemExportConfigsAppConfig($routeProvider) {
        $routeProvider
            .when('/export-configs', {
                templateUrl: ManagersContext.wemAppPath + '/wem-export-configs/export-configs-list.html',
                controller: 'ExportConfigsListController',
                controllerAs: 'exportConfigListCtrl'
            })
            .when('/export-configs/:configId', {
                templateUrl: ManagersContext.wemAppPath + '/wem-export-configs/export-config-edit.html',
                controller: 'ExportConfigsEditController',
                controllerAs: 'exportConfigsEditCtrl',
                resolve: {
                    // resolve profile here to avoid async issue using deferred API
                    "currentExportConfig": function ($q, $route, unomiExportConfigService) {
                        if($route.current.params.configId == 'new') {
                            return {};
                        }
                        var currentExportConfig = $q.defer();
                        unomiExportConfigService.getExportConfig($route.current.params.configId).then(function (response) {
                            currentExportConfig.resolve(response.data);
                        });
                        return currentExportConfig.promise;
                    }
                }
            })
            .otherwise({
                redirectTo: angular.isDefined(ManagersContext.wemDefaultRoute) ? ('/' + ManagersContext.wemDefaultRoute) : '/export-configs'
            });
    }
})();