(function() {
    'use strict';

    angular.module('wemGoalsApp').controller('GoalDownloadGoalController', GoalDownloadGoalController);

    GoalDownloadGoalController.$inject = ['$scope', 'jcrService'];

    function GoalDownloadGoalController($scope, jcrService) {
        $scope._goal = {};
        $scope.goal = $scope.$parent.goal;
        $scope._goal.targetFile = ManagersUtils.getProperty($scope.goal, "targetEvent.parameterValues.filePath");


        var doSave = function(callback) {
            // construct download events:
            $scope.goal.metadata.enabled = true;
            $scope.goal.startEvent = {
                "parameterValues": {
                },
                "type": "sessionCreatedEventCondition"
            };
            $scope.goal.targetEvent = {
                "parameterValues": {
                    "filePath": $scope._goal.targetFile
                },
                "type": "downloadEventCondition"
            };

            jcrService.addMixin("live", null, $scope._goal.targetFile, "wemmix:trackDownloadedFile", {}, true).then(function (response) {
                // mixin added, save goal on Apache Unomi
            });

            if (callback) {
                callback();
            }
        };

        if ($scope.callback) {
            $scope.callback.validate = function (callback) {
                if (callback) {
                    callback();
                }
            };

            $scope.callback.save = function (callback) {
                doSave(callback);
            }
        }
    }
})();
