(function() {
    'use strict';

    angular.module('wemGoalsApp').controller('GoalPageVisitGoalController', GoalPageVisitGoalController);

    GoalPageVisitGoalController.$inject = ['$scope'];

    function GoalPageVisitGoalController($scope) {
        $scope._goal = {};
        $scope.goal = $scope.$parent.goal;
        $scope._goal.targetPath = ManagersUtils.getProperty($scope.goal, "targetEvent.parameterValues.pagePath");

        var doSave = function(callback) {
            // construct page visit event:
            $scope.goal.metadata.enabled = true;
            $scope.goal.startEvent = {
                "parameterValues": {
                },
                "type": "sessionCreatedEventCondition"
            };
            $scope.goal.targetEvent = {
                "parameterValues": {
                    "pagePath": $scope._goal.targetPath
                },
                "type": "pageViewEventCondition"
            };

            if(callback) {
                callback();
            }
        };

        if ($scope.callback) {
            $scope.callback.validate = function (callback) {
                if (callback) {
                    callback();
                }
            };

            $scope.callback.save = function (callback) {
                doSave(callback);
            }
        }
    }
})();
