(function() {
    'use strict';

    angular.module('wemGoalsApp').config(wemGoalsAppConfig);

    wemGoalsAppConfig.$inject = ['$routeProvider'];

    function wemGoalsAppConfig($routeProvider) {
        $routeProvider
            .when('/goals', {
                templateUrl: ManagersContext.wemAppPath + '/wem-goals/goals-list.html',
                controller: 'GoalsListController',
                reloadOnSearch: false,
                resolve: {
                    // resolve rule here to avoid async issue using deferred API
                    "currentCampaign": function () {
                        return undefined
                    }
                }
            })
            .when('/newGoal', {
                templateUrl: ManagersContext.wemAppPath + '/wem-goals/goal-create.html',
                controller: 'GoalCreateController',
                resolve: {
                    "goal": function () {
                        return undefined
                    }
                }
            })
            .when('/goal/:goalId', {
                templateUrl: ManagersContext.wemAppPath + '/wem-goals/goal-create.html',
                controller: 'GoalCreateController',
                resolve: {
                    // resolve goal here to avoid async issue using deferred API
                    "goal": function( $q, $route, unomiGoalService) {
                        var goal = $q.defer();
                        unomiGoalService.getGoal($route.current.params.goalId).then(function(response){
                            goal.resolve(response.data);
                        });
                        return goal.promise;
                    }
                }
            })
            .when('/goal-report/:goalId', {
                templateUrl: ManagersContext.wemAppPath + '/wem-goals/goal-report.html',
                controller: 'GoalReportController',
                resolve: {
                    // resolve goal here to avoid async issue using deferred API
                    "goal": function ($q, $route, unomiGoalService) {
                        var goal = $q.defer();
                        unomiGoalService.getGoal($route.current.params.goalId).then(function (response) {
                            goal.resolve(response.data);
                        });
                        return goal.promise;
                    }
                }
            })
            .otherwise({
                redirectTo: '/goals'
            });
    }
})();
