(function() {
    'use strict';

    angular.module('wemGoalsApp').controller('SessionsListModalController', SessionsListModalController);

    SessionsListModalController.$inject = ['$scope', 'scopeParent'];

    function SessionsListModalController($scope, scopeParent) {
        // get back the query without the aggregate
        var queryWithoutAggregate = {};
        $scope._addConditionToQuery = function (query, condition) {
            if (query.condition) {
                query.condition.parameterValues.subConditions.push(condition);
            } else {
                query.condition = {
                    "type": "booleanCondition",
                    "parameterValues": {
                        "operator": "and",
                        "subConditions": []
                    }
                };
                $scope._addConditionToQuery(query, condition);
            }
        };

        var parentFacets = angular.copy(scopeParent.facets);
        var conditions = [];
        var clickedCondition = {
            "type": "sessionPropertyCondition",
            "parameterValues": {
                "propertyName": scope.getCurrentProperty(),
                "comparisonOperator": "equals",
                "propertyValue": "male"
            }
        };
        conditions.push(clickedCondition);
        angular.forEach(parentFacets, function (value, key) {
            var facet = value;
            if (facet) {
                if (facet.conditions && facet.conditions.length > 0) {
                    for (var i = 0; i < facet.conditions.length; i++) {
                        conditions.push(angular.copy(facet.conditions[i]));
                    }
                }
            }
        });

        //
        scope.getCurrentProperty();

        // Ajout de la condition sur la ligne selectionnée
        // Requete au service Unomi.
        // $query('sessions');


        // recuperation de toutes les conditions.
        $scope.dtColumnsSession = angular.copy(scopeParent.dtColumns);
        $scope.dtOptionsSessions = angular.copy(scopeParent.dtOptions);


    }
})();
