(function() {
    'use strict';

    angular.module('wemImportConfigsApp').controller('ImportConfigsListController', ImportConfigsListController);

    ImportConfigsListController.$injecet = ['$route', '$location', 'unomiImportConfigService'];

    function ImportConfigsListController($route, $location, unomiImportConfigService) {
        var vm = this;

        vm.onChangeFilterByType = onChangeFilterByType;
        vm.newImportConfig = newImportConfig;
        vm.editImportConfig = editImportConfig;
        vm.reload = reload;

        _init();

        function onChangeFilterByType() {
            if(vm.filterByType == 'all') {
                vm.importConfigs = angular.copy(vm.importConfigsAll);
            } else {
                vm.importConfigs = R.filter(function(elt) {
                    return elt.configType == vm.filterByType;
                }, vm.importConfigsAll);
            }
        }

        function newImportConfig(importConfigId) {
            $location.path('/import-configs/new');
        }

        function editImportConfig(importConfigId) {
            $location.path('/import-configs/' + importConfigId);
        }

        function reload() {
            $route.reload();
        }

        // Private functions
        function _init() {
            vm.filterByType = 'all';

            _getImportConfigs();
        }

        function _getImportConfigs() {
            unomiImportConfigService.getAll().then(function(response) {
                vm.importConfigsAll = response.data;
                vm.importConfigs = angular.copy(vm.importConfigsAll);
            });
        }
    }
})();
