(function() {
    'use strict';

    angular.module('wemIncomingSearchesApp').config(wemIncomingSearchesAppConfig);

    wemIncomingSearchesAppConfig.$inject = ['$routeProvider'];

    function wemIncomingSearchesAppConfig($routeProvider) {
        $routeProvider
            .when('/incoming-searches', {
                templateUrl: ManagersContext.wemAppPath + '/wem-incoming-searches/incoming-searches-list.html',
                controller: 'IncomingSearchesListController'
            })
            .when('/incoming-search/:queryID', {
                templateUrl: ManagersContext.wemAppPath + '/wem-incoming-searches/incoming-search-details.html',
                controller: 'IncomingSearchDetailsController'
            })
            .when('/incoming-search/by-referrers/:queryID', {
                templateUrl: ManagersContext.wemAppPath + '/wem-incoming-searches/incoming-search-by-referrers.html',
                controller: 'IncomingSearchByReferrersController'
            })
            .when('/incoming-search/:queryID/profile/:profileId', {
                templateUrl: ManagersContext.wemAppPath + '/wem-profiles/manage-profile.html',
                controller: 'ManageProfileController',
                resolve: {
                    // resolve profile here to avoid async issue using deferred API
                    "profile": function ($q, $route, unomiProfileService) {
                        var profile = $q.defer();
                        unomiProfileService.getProfile($route.current.params.profileId).then(function (response) {
                            profile.resolve(response.data);
                        });
                        return profile.promise;
                    }
                }
            })
            .when('/incoming-search/:queryID/profile/:profileId/:sessionId', {
                templateUrl: ManagersContext.wemAppPath + '/wem-profiles/profile-session.html',
                controller: 'ProfileSessionController'
            })
            .otherwise({
                redirectTo: '/incoming-searches'
            });
    }
})();
