(function() {
    'use strict';

    angular.module('wemMostVisitedPagesApp').directive("mostVisitedPagesWidget", mostVisitedPagesWidget);

    function mostVisitedPagesWidget() {
        return {
            restrict: "E",
            scope: {
                limit: '='
            },
            template: '<div ng-include="templateUrl"></div>',
            controller: MostVisitedPagesWidgetController
        };
    }

    MostVisitedPagesWidgetController.$inject = ['$scope', 'internalSearchService', 'dataTableService'];

    function MostVisitedPagesWidgetController($scope, internalSearchService, dataTableService) {
        dataTableService.setPromise(internalSearchService.getMostVisitedList($scope.limit));

        $scope.dtOptions = dataTableService.generateDataTableOptions(
            {paging: false, ordering:false}
        );

        var columns = [
            {name: 'url', bundleKey: 'serverSettings.mostVisitedPages.url'},
            {name: 'occurrences', bundleKey: 'serverSettings.mostVisitedPages.occurrences'}
        ];
        $scope.dtColumns = dataTableService.generateDataTableColumns(columns);

        // resolve template
        $scope.templateUrl = ManagersContext.wemAppPath + "/wem-most-visited-pages/most-visited-pages-widget.directive.html";
    }
})();
