(function() {
    'use strict';

    angular.module('wemMostVisitedPagesApp').config(wemMostVisitedPagesAppConfig);

    wemMostVisitedPagesAppConfig.$inject = ['$routeProvider'];

    function wemMostVisitedPagesAppConfig($routeProvider) {
        $routeProvider
            .when('/mostvisited', {
                templateUrl: ManagersContext.wemAppPath + '/wem-most-visited-pages/most-visited-pages-list.html',
                controller: 'MostVisitedPagesListController'

            })
            .when('/mostvisited/selected', {
                templateUrl: ManagersContext.wemAppPath + '/wem-most-visited-pages/most-visited-page-details.html',
                controller: 'MostVisitedPageDetailsController'
            })
            .when('/mostvisited/selected/profile/:profileId', {
                templateUrl: ManagersContext.wemAppPath + '/wem-profiles/manage-profile.html',
                controller: 'ManageProfileController',
                resolve: {
                    // resolve profile here to avoid async issue using deferred API
                    "profile": function ($q, $route, unomiProfileService) {
                        var profile = $q.defer();
                        unomiProfileService.getProfile($route.current.params.profileId).then(function (response) {
                            var profileData = response.data;
                            if(profileData) {
                                profile.resolve(profileData);
                            } else {
                                profile.reject("profile_not_found")
                            }

                        });
                        return profile.promise;
                    }
                }
            })
            .otherwise({
                redirectTo: '/mostvisited'
            });
    }
})();
