(function() {
    'use strict';

    angular.module('wemProfilesApp').config(wemProfilesAppConfig);

    wemProfilesAppConfig.$inject = ['$routeProvider'];

    function wemProfilesAppConfig($routeProvider) {
        $routeProvider
            .when('/profiles', {
                templateUrl: ManagersContext.wemAppPath + '/wem-profiles/profiles-list.html',
                controller: 'ProfilesListController'
            })
            .when('/profile/:profileId', {
                templateUrl: ManagersContext.wemAppPath + '/wem-profiles/manage-profile.html',
                controller: 'ManageProfileController',
                resolve: {
                    // resolve profile here to avoid async issue using deferred API
                    "profile": function ($q, $route, unomiProfileService) {
                        var profile = $q.defer();
                        unomiProfileService.getProfile($route.current.params.profileId).then(function (response) {
                            profile.resolve(response.data);
                        });
                        return profile.promise;
                    }
                }
            })
            .when('/profile/:profileId/:sessionId', {
                templateUrl: ManagersContext.wemAppPath + '/wem-profiles/profile-session.html',
                controller: 'ProfileSessionController'
            })
            .when('/personas', {
                templateUrl: ManagersContext.wemAppPath + '/wem-profiles/personas-list.html'
            })
            .when('/persona/:profileId', {
                templateUrl: ManagersContext.wemAppPath + '/wem-profiles/manage-profile.html',
                controller: 'ManageProfileController',
                resolve: {
                    // resolve profile here to avoid async issue using deferred API
                    "profile": function ($q, $route, unomiProfileService) {
                        var profile = $q.defer();
                        unomiProfileService.getProfile($route.current.params.profileId, 'personas').then(function (response) {
                            profile.resolve(response.data);
                        });
                        return profile.promise;
                    }
                }
            })
            .when('/persona/:profileId/:sessionId', {
                templateUrl: ManagersContext.wemAppPath + '/wem-profiles/profile-session.html',
                controller: 'ProfileSessionController'
            })
            .when('/newPersona', {
                templateUrl: ManagersContext.wemAppPath + '/wem-profiles/manage-persona.html',
                controller: 'ManageProfileController',
                resolve: {
                    // resolve profile here to avoid async issue using deferred API
                    "profile": function () {
                        return {
                            "itemId": "newPersona",
                            "itemType": "persona",
                            "properties": {
                            },
                            "systemProperties": {
                            },
                            "segments": [],
                            "scores": {}
                        }
                    }
                }
            })
            .otherwise({
                redirectTo: angular.isDefined(ManagersContext.wemDefaultRoute) ? ('/' + ManagersContext.wemDefaultRoute) : '/profiles'
            });
    }
})();