(function() {
    'use strict';
    angular.module('wemProfilesApp').controller('SaveAsModalController', SaveAsModalController);

    SaveAsModalController.$inject = ['$scope', '$uibModalInstance', 'unomiSegmentService', 'i18nService', 'unomiListService', 'unomiProfileService', 'notificationService', 'type'];

    function SaveAsModalController($scope, $uibModalInstance, unomiSegmentService, i18nService, unomiListService, unomiProfileService, notificationService, type) {
        $scope.metadata = {
            id: ManagersUtils.generateId(),
            scope: ManagersContext.dmfScope,
            enabled: true
        };

        $scope.shared = false;

        if (type == "segment") {
            $scope.save = function () {
                var currentSegment = {
                    metadata: $scope.metadata,
                    condition: unomiProfileService.constructCondition(unomiProfileService.getSelectedTab().baseCondition, unomiProfileService.getSelectedTab().searchCondition, null, false, unomiProfileService.getSelectedTab().type)
                };

                unomiSegmentService.setSegment(currentSegment, $scope.shared)
                    .then(function () {
                        notificationService.successToast(i18nService.format('serverSettings.manageSegments.create.success', currentSegment.metadata.name));
                    },
                    function () {
                        notificationService.errorToast(i18nService.message('serverSettings.manageSegments.create.error'));
                    });
                $uibModalInstance.close();
            };
        } else if (type == "list") {
            $scope.save = function () {
                var list = {
                    metadata: $scope.metadata
                };
                unomiListService.setList(list, $scope.shared)
                    .then(function () {
                        var update = {
                            condition: unomiProfileService.constructCondition(unomiProfileService.getSelectedTab().baseCondition, unomiProfileService.getSelectedTab().searchCondition, null, true, unomiProfileService.getSelectedTab().type),
                            propertyName: "systemProperties.lists",
                            propertyValue: $scope.metadata.id,
                            strategy: "addValue"
                        };
                        unomiProfileService.batchProfilesUpdate(update)
                            .then(function () {
                                notificationService.successToast(i18nService.format('serverSettings.manageLists.create.success', list.metadata.name));
                                if (unomiProfileService.getSelectedTab() && unomiProfileService.getSelectedTab().dtInstance) {
                                    unomiProfileService.getSelectedTab().dtInstance.DataTable.draw()
                                }
                            },
                            function () {
                                notificationService.errorToast(i18nService.message('serverSettings.manageLists.create.error'));
                            });
                    });
                $uibModalInstance.close();
            };
        }

        $scope.cancel = function () {
            $uibModalInstance.dismiss('cancel');
        }
    }
})();