(function() {
    'use strict';

    angular.module('wemReferrersApp').config(wemReferrersAppConfig);

    wemReferrersAppConfig.$inject = ['$routeProvider'];

    function wemReferrersAppConfig($routeProvider) {
    $routeProvider
        .when('/referrers', {
            templateUrl: ManagersContext.wemAppPath + '/wem-referrers/referrers-list.html',
            controller: 'ReferrersListController'
        })
        .when('/referrer/:referrerId', {
            templateUrl: ManagersContext.wemAppPath + '/wem-referrers/referrer-details.html',
            controller: 'ReferrerDetailsController'
        })
        .when('/referrer/queries/:referrerId', {
            templateUrl: ManagersContext.wemAppPath + '/wem-referrers/referrer-queries.html',
            controller: 'ReferrerQueriesController'
        })
        .when('/referrer/:referrerId/profile/:profileId', {
            templateUrl: ManagersContext.wemAppPath + '/wem-profiles/manage-profile.html',
            controller: 'ManageProfileController',
            resolve: {
                // resolve profile here to avoid async issue using deferred API
                "profile": function ($q, $route, unomiProfileService) {
                    var profile = $q.defer();
                    unomiProfileService.getProfile($route.current.params.profileId).then(function (response) {
                        profile.resolve(response.data);
                    });
                    return profile.promise;
                }
            }
        })
        .when('/referrer/:referrerId/profile/:profileId/:sessionId', {
            templateUrl: ManagersContext.wemAppPath + '/wem-profiles/profile-session.html',
            controller: 'ProfileSessionController'
        })
        .otherwise({
            redirectTo: '/referrers'
        });
    }
})();
