/**
 * Created by amidani on 31/05/2017.
 */
describe('import-config.service', function () {

    var $httpBackend, unomiImportConfigService;

    // Set up the module
    beforeEach(module('wemImportConfigsApp'));

    beforeEach(inject(function($injector) {
        // Set up the mock http service responses
        $httpBackend = $injector.get('$httpBackend');
        unomiImportConfigService = $injector.get( 'unomiImportConfigService' );
        // backend definition common for all tests
        $httpBackend.whenGET('/cxs/importConfiguration/f57f1f86-97bf-4ba0-b4e4-7d5e77e7c0bd')
            .respond(200,
                {
                    "itemId": "f57f1f86-97bf-4ba0-b4e4-7d5e77e7c0bd",
                    "itemType": "importConfig",
                    "scope": "integration",
                    "name": "test_recurrent",
                    "description": "Just test recurrent import",
                    "configType": "recurrent",
                    "properties": {
                        "source": "file:///Users/amidani/Public/test/?fileName=profiles.csv&move=.done&consumer.delay=20000",
                        "mapping": {
                            "firstName": 0,
                            "lastName": 1
                        }
                    },
                    "mergingProperty": "firstName",
                    "overwriteExistingProfiles": true,
                    "propertiesToOverwrite": null,
                    "active": true
                }
            );
        $httpBackend.whenGET('/cxs/importConfiguration/')
            .respond(200,
                [
                    {
                        "itemId": "f57f1f86-97bf-4ba0-b4e4-7d5e77e7c0bd",
                        "itemType": "importConfig",
                        "scope": "integration",
                        "name": "test_recurrent",
                        "description": "Just test recurrent import",
                        "configType": "recurrent",
                        "properties": {
                            "source": "file:///Users/amidani/Public/test/?fileName=profiles.csv&move=.done&consumer.delay=20000",
                            "mapping": {
                                "firstName": 0,
                                "lastName": 1
                            }
                        },
                        "mergingProperty": "firstName",
                        "overwriteExistingProfiles": true,
                        "propertiesToOverwrite": null,
                        "active": true
                    }
                ]
            );
    }));


    afterEach(function() {
        $httpBackend.verifyNoOutstandingExpectation();
        $httpBackend.verifyNoOutstandingRequest();
    });


    it('Get all import configs', function () {
        unomiImportConfigService.getAll().then(function (response) {
            expect(response.data.length).toEqual(1);
        });

        $httpBackend.flush();
    });

    it('Get import config by id', function () {
        unomiImportConfigService.getImportConfig("f57f1f86-97bf-4ba0-b4e4-7d5e77e7c0bd").then(function (response) {
            expect(response.data.name).toEqual("test_recurrent");
            expect(response.data.mergingProperty).toEqual("firstName");
        });

        $httpBackend.flush();
    });
});