<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="user" uri="http://www.jahia.org/tags/user" %>
<%@ taglib prefix="wem" uri="http://www.jahia.org/tags/wem" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>

<jsp:include page="../../commons/adminBaseImports.ui-bootstrap.jsp"/>

<template:addResources type="javascript"
                       resources="
                       marketing-factory/builds/wemProfilesApp.js,
                       marketing-factory/builds/wemGoalsApp.js,
                       marketing-factory/builds/wemMostVisitedPagesApp.js,
                       marketing-factory/builds/wemManageOptimizationTestApp.js"/>

<c:choose>
    <c:when test="${wem:isAvailable(renderContext.site.siteKey)}">
        <c:set var="variants" value="${jcr:getChildrenOfType(currentNode, 'wemnt:pageVariant')}" />

        <c:set var="doubleQuotes">"</c:set>
        <c:set var="doubleQuotesReplace">\"</c:set>
        <c:set var="backslash">\</c:set>
        <c:set var="backslashReplace">\\</c:set>

        <script type="text/javascript">
            var currentDMFNodeUUID = "${currentNode.identifier}";
            var currentDMFNodePath = "${currentNode.path}";
            var currentDMFNodeDisplayName = "${currentNode.displayableName}";
            var currentDMFNodeName = "${currentNode.name}";
            var goalId = "${currentNode.properties['wem:goalId'].string}";
            var controlVariantId = "${currentNode.properties['wem:controlVariant'].string}";
            var urlBase = '${url.base}';
            var variants = {};
            variants["${currentNode.identifier}"] = "${fn:replace(fn:replace(currentNode.displayableName,backslash, backslashReplace), doubleQuotes , doubleQuotesReplace)}";
            <c:forEach items="${variants}" var="variantNode">
            variants["${variantNode.identifier}"] = "${fn:replace(fn:replace(variantNode.displayableName,backslash, backslashReplace), doubleQuotes , doubleQuotesReplace)}";
            </c:forEach>

            // NECESSARY TO FIX IE ISSUE RELATED TO IFRAME AND FOCUS ON INPUTS, QAMF-223, QAMF-453
            $(document).ready(function(){
                $("#ieFixInputs").focus().hide();
            })
        </script>
        <input id="ieFixInputs" type="text">
        <div ng-app="wemManageOptimizationTestApp" >
            <div ng-controller="ManageOptimizationTestController" ng-init="init()" ng-class="goalExist ? 'opttstpagegoalexist' : 'opttstpage'">

                <div ng-if="goalExist">
                    <div class="pull-right">
                        <div class="btn-group">
                            <button type="button" class="btn btn-danger light-grey-bg" ng-click="reset()">
                                <fmt:message key="wemnt_optimizationTest.reset"/>
                            </button>
                        </div>
                    </div>

                    <h2>{{goalTitle}}</h2>

                    <ng-include src="goalTemplateView"></ng-include>

                    <goal-report-table goal="goal" properties="properties" ng-model="qualitativeReportData" type="qualitative"
                                       query-row-hook="reportTableQueryRowHook" query-hook="reportTableQueryHook"
                                       table-columns-hook="reportTableColumnsHook"></goal-report-table>
                </div>

                <div ng-show="!goalExist">
                    <div class="btn-group tabsperscontsel" role="group">
                        <button type="button" class="btn btn-primary"  ng-show="!showGoalForm" ng-click="showGoalForm = true" message-key="wemnt_optimizationTest.add"></button>
                    </div>

                    <form name="goalOptimizationForm" ng-show="showGoalForm">
                        <div class="group groupModal">
                            <div class="selectModCont">
                                <label for="goalType"><span message-key="serverSettings.manageGoals.modal.newGoal.type"></span></label>
                                <select id="goalType" ng-model="goal.type" class="form-control" ng-options="goalTag as goalTag.name for goalTag in goalTags">
                                </select>
                            </div>
                        </div>

                        <div ng-include="getEditTemplate()" class=""></div>
                    </form>
                </div>
            </div>
        </div>
        <template:module path="*" nodeTypes="${requestScope[constraints]}" />
    </c:when>
    <c:otherwise>
        <div style="color: red">
            <fmt:message key="wem.error.apacheUnomi"/>
        </div>
    </c:otherwise>
</c:choose>