<%@ taglib prefix="jcr" uri="http://www.jahia.org/tags/jcr" %>
<%@ taglib prefix="fmt" uri="http://java.sun.com/jsp/jstl/fmt" %>
<%@ taglib prefix="c" uri="http://java.sun.com/jsp/jstl/core" %>
<%@ taglib prefix="utility" uri="http://www.jahia.org/tags/utilityLib" %>
<%@ taglib prefix="template" uri="http://www.jahia.org/tags/templateLib" %>
<%@ taglib prefix="fn" uri="http://java.sun.com/jsp/jstl/functions" %>
<%@ taglib prefix="form" uri="http://www.springframework.org/tags/form" %>
<%@ taglib prefix="functions" uri="http://www.jahia.org/tags/functions" %>
<%@ taglib prefix="user" uri="http://www.jahia.org/tags/user" %>
<%@ taglib prefix="wem" uri="http://www.jahia.org/tags/wem" %>
<%--@elvariable id="currentNode" type="org.jahia.services.content.JCRNodeWrapper"--%>
<%--@elvariable id="out" type="java.io.PrintWriter"--%>
<%--@elvariable id="script" type="org.jahia.services.render.scripting.Script"--%>
<%--@elvariable id="scriptInfo" type="java.lang.String"--%>
<%--@elvariable id="workspace" type="java.lang.String"--%>
<%--@elvariable id="renderContext" type="org.jahia.services.render.RenderContext"--%>
<%--@elvariable id="currentResource" type="org.jahia.services.render.Resource"--%>
<%--@elvariable id="url" type="org.jahia.services.render.URLGenerator"--%>

<jsp:include page="../../commons/adminBaseImports.ui-bootstrap.jsp"/>

<template:addResources type="javascript"
                       resources="
                       marketing-factory/builds/wemProfilesApp.js,
                       marketing-factory/builds/wemGoalsApp.js,
                       marketing-factory/builds/wemMostVisitedPagesApp.js,
                       marketing-factory/builds/wemManageOptimizationTestApp.js"/>

<c:choose>
    <c:when test="${wem:isAvailable(renderContext.site.siteKey)}">
        <c:set var="variantsNode" value="${jcr:getChildrenOfType(currentNode, 'wemnt:pageVariant')}" />

        <c:choose>
            <c:when test="${not empty currentNode.properties['wem:variantsTraffic'].string}">
                <c:set var="variantsTraffic" value="${currentNode.properties['wem:variantsTraffic'].string}"/>
            </c:when>
            <c:otherwise>
                <c:set var="variantsTraffic" value="{}"/>
            </c:otherwise>
        </c:choose>

        <template:addResources>
            <style>
                .widthTooltip {
                    width: 60%;
                }
                .widthTooltip .tooltip-inner {
                    width: 100%;
                    max-width: 100%;
                }
            </style>
        </template:addResources>

        <script type="text/javascript">
            var variantsTraffic = ${variantsTraffic};
            var variants = [];

            variants.push({
                name: "${functions:escapeJavaScript(currentNode.displayableName)}",
                nodeIdentifier: "${currentNode.identifier}"
            });

            <c:forEach items="${variantsNode}" var="variantNode">
            variants.push({
                name: "${functions:escapeJavaScript(variantNode.displayableName)}",
                nodeIdentifier: "${variantNode.identifier}"
            });
            </c:forEach>

            // NECESSARY TO FIX IE ISSUE RELATED TO IFRAME AND FOCUS ON INPUTS, QAMF-223, QAMF-453
            $(document).ready(function(){
                $("#ieFixInputs").focus().hide();
            })
        </script>

        <input id="ieFixInputs" type="text">

        <div ng-app="wemManageOptimizationTestApp" class="row">
            <div class="col-md-12">
                <div ng-controller="ManageOptimizationTestTrafficController">
                    <div class="box-3 reportDTBox">
                        <div class="box-3-title clearfix">
                            <h3 class="box-3-title pull-left"><fmt:message key="label.engineTab.dmfTrafficManagement"/></h3>
                            <div ng-if="hasVariants" class="pull-right">
                                <form class="form-inline">
                                    <div class="form-group">
                                        <label message-key="wem_optimizationTest.customTrafficManagementEngine.label.totalTraffic"></label>
                                        <input class="form-control" type="number" ng-model="totalTraffic" disabled/>
                                        <div class="text-danger" ng-show="totalTraffic != 100" message-key="wem_optimizationTest.customTrafficManagementEngine.error.totalTraffic"></div>
                                    </div>
                                </form>
                            </div>
                        </div>
                        <div ng-if="hasVariants">
                            <table class="table table-striped table-hover table-selectable">
                                <thead>
                                <tr>
                                    <th message-key="wem_optimizationTest.customTrafficManagementEngine.label.variants"></th>
                                    <th message-key="wem_optimizationTest.customTrafficManagementEngine.label.traffic"></th>
                                </tr>
                                </thead>
                                <tbody>
                                <tr ng-repeat="variant in variants">
                                    <td>
                                        <span tooltip="{{ variant.name }}" tooltip-placement="right" tooltip-class="widthTooltip">{{ trimVariantName(variant.name) }}</span>
                                    </td>
                                    <td>
                                        <input ng-model="variant.traffic" type="number" min="0" max="100" ng-change="updateTotalTraffic()">
                                    </td>
                                </tr>
                                </tbody>
                            </table>
                        </div>

                        <div ng-if="!hasVariants">
                            <span message-key="wem_optimizationTest.customTrafficManagementEngine.message.noVariants"></span>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </c:when>
    <c:otherwise>
        <div style="color: red">
            <fmt:message key="wem.error.apacheUnomi"/>
        </div>
    </c:otherwise>
</c:choose>